Index: squid/src/store.c
diff -u squid/src/store.c:1.1.1.2 squid/src/store.c:1.1.1.2.10.1
--- squid/src/store.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/store.c	Fri Nov 10 10:44:52 2000
@@ -35,6 +35,10 @@
 
 #include "squid.h"
 
+#ifdef	HPL_REPL
+#include "heap.h"
+#endif	/* HPL_REPL */
+
 #define REBUILD_TIMESTAMP_DELTA_MAX 2
 
 #define STORE_IN_MEM_BUCKETS		(229)
@@ -79,7 +83,6 @@
 static int storeEntryLocked(const StoreEntry *);
 static int storeEntryValidLength(const StoreEntry *);
 static void storeGetMemSpace(int);
-static void storeHashDelete(StoreEntry *);
 static MemObject *new_MemObject(const char *, const char *);
 static void destroy_MemObject(StoreEntry *);
 static FREE destroy_StoreEntry;
@@ -92,7 +95,14 @@
 /*
  * local variables
  */
+#ifdef	HPL_REPL
+/*
+ * The heap equivalent of inmem_list, inmem_heap, is in globals.c so other
+ * modules can access it when updating object metadata (e.g., refcount)
+ */
+#else	/* HPL_REPL */
 static dlink_list inmem_list;
+#endif	/* HPL_REPL */
 static int store_pages_max = 0;
 static int store_swap_high = 0;
 static int store_swap_low = 0;
@@ -110,6 +120,9 @@
     mem->swapout.fd = -1;
     mem->object_sz = -1;
     mem->fd = -1;
+#if HPL_REPL
+    mem->n.ode.id = -1;
+#endif
     /* XXX account log_url */
     debug(20, 3) ("new_MemObject: returning %p\n", mem);
     return mem;
@@ -120,10 +133,18 @@
 {
     StoreEntry *e = NULL;
     e = memAllocate(MEM_STOREENTRY);
-    if (mem_obj_flag)
+    if (mem_obj_flag) {
 	e->mem_obj = new_MemObject(url, log_url);
+#if HPL_REPL
+	e->mem_obj->entry = e;
+#endif
+        e->s = memAllocate(MEM_STORESWAPLOGDATA);
+        e->Sexpires = e->Slastmod = e->Slastref = e->Stimestamp = -1;
+    }
+#if HPL_REPL
+    e->n.ode.id = -1;
+#endif
     debug(20, 3) ("new_StoreEntry: returning %p\n", e);
-    e->expires = e->lastmod = e->lastref = e->timestamp = -1;
     return e;
 }
 
@@ -132,7 +153,7 @@
 {
     MemObject *mem = e->mem_obj;
     const Ctx ctx = ctx_enter(mem->url);
-    debug(20, 3) ("destroy_MemObject: destroying %p\n", mem);
+    debug(20, 4) ("destroy_MemObject: destroying %p\n", mem);
     e->mem_obj = NULL;
     if (!shutting_down)
 	assert(mem->swapout.fd == -1);
@@ -161,12 +182,16 @@
 destroy_StoreEntry(void *data)
 {
     StoreEntry *e = data;
-    debug(20, 3) ("destroy_StoreEntry: destroying %p\n", e);
+    debug(20, 4) ("destroy_StoreEntry: destroying %p\n", e);
     assert(e != NULL);
     if (e->mem_obj)
 	destroy_MemObject(e);
     storeHashDelete(e);
-    assert(e->key == NULL);
+    if (e->s)
+	destroy_storeSwapLogData(e->s);
+#ifndef MMAPSTORE
+    assert(e->Skey == NULL);
+#endif
     memFree(e, MEM_STOREENTRY);
 }
 
@@ -177,18 +202,33 @@
 {
     debug(20, 3) ("storeHashInsert: Inserting Entry %p key '%s'\n",
 	e, storeKeyText(key));
-    e->key = storeKeyDup(key);
-    hash_join(store_table, (hash_link *) e);
+#ifdef MMAPSTORE
+    if (key != e->s->key)
+	xmemcpy(e->s->key, key, MD5_DIGEST_CHARS);
+#else
+    e->Skey = storeKeyDup(key);
+#endif
+    if(hash_join(store_table, (hash_link *) e))
+	debug(20, 0) ("storeHashInsert: duplicate entry %p %s\n",e,storeUrl(e));
+    if (e->Sswap_file_number < 0)
+	return;
+    #if	!HPL_REPL
     dlinkAdd(e, &e->lru, &store_list);
+    #endif	/* HPL_REPL */
 }
 
-static void
+void
 storeHashDelete(StoreEntry * e)
 {
-    hash_remove_link(store_table, (hash_link *) e);
+    if(hash_remove_link(store_table, (hash_link *) e))
+	debug(20, 2) ("storeHashDelete: missing entry %p %s\n",e,storeUrl(e));
+    #if	!HPL_REPL
     dlinkDelete(&e->lru, &store_list);
-    storeKeyFree(e->key);
-    e->key = NULL;
+    #endif	/* HPL_REPL */
+#ifndef MMAPSTORE
+    storeKeyFree(e->Skey);
+    e->Skey = NULL;
+#endif
 }
 
 /* -------------------------------------------------------------------------- */
@@ -202,7 +242,7 @@
     if (e->mem_obj == NULL)
 	return;
     debug(20, 3) ("storePurgeMem: Freeing memory-copy of %s\n",
-	storeKeyText(e->key));
+	storeKeyText(e->Skey));
     storeSetMemStatus(e, NOT_IN_MEMORY);
     destroy_MemObject(e);
     if (e->swap_status != SWAPOUT_DONE)
@@ -213,28 +253,37 @@
 storeLockObject(StoreEntry * e)
 {
     if (e->lock_count++ == 0) {
+      #ifdef	HPL_REPL
+      /* there is no reason to take any action here.
+	 Squid by default is moving locked objects to the end of the LRU
+	 list to keep them from getting bumped into by the replacement
+	 algorithm.  We can't do that so we will just have to handle them.
+      */
+      debug(20, 4) ("storeLockObject: just locked node %d\n", e->n.ode.id);
+      #else	/* HPL_REPL */
 	dlinkDelete(&e->lru, &store_list);
 	dlinkAdd(e, &e->lru, &store_list);
+      #endif	/* HPL_REPL */
     }
-    debug(20, 3) ("storeLockObject: key '%s' count=%d\n",
-	storeKeyText(e->key), (int) e->lock_count);
-    e->lastref = squid_curtime;
+    debug(20, 4) ("storeLockObject: key '%s' count=%d\n",
+	storeKeyText(e->Skey), (int) e->lock_count);
+    e->Slastref = squid_curtime;
 }
 
 void
 storeReleaseRequest(StoreEntry * e)
 {
-    if (EBIT_TEST(e->flags, RELEASE_REQUEST))
+    if (EBIT_TEST(e->Sflag, RELEASE_REQUEST))
 	return;
-    debug(20, 3) ("storeReleaseRequest: '%s'\n", storeKeyText(e->key));
-    EBIT_SET(e->flags, RELEASE_REQUEST);
+    debug(20, 3) ("storeReleaseRequest: '%s'\n", storeKeyText(e->Skey));
+    EBIT_SET(e->Sflag, RELEASE_REQUEST);
     /*
      * Clear cachable flag here because we might get called before
      * anyone else even looks at the cachability flag.  Also, this
      * prevents httpMakePublic from really setting a public key.
      */
-    EBIT_CLR(e->flags, ENTRY_CACHABLE);
-    storeSetPrivateKey(e);
+    EBIT_CLR(e->Sflag, ENTRY_CACHABLE);
+    storeSetPrivateKey(e, 1);
 }
 
 /* unlock object, return -1 if object get released after unlock
@@ -244,13 +293,13 @@
 {
     e->lock_count--;
     debug(20, 3) ("storeUnlockObject: key '%s' count=%d\n",
-	storeKeyText(e->key), e->lock_count);
+	storeKeyText(e->Skey), e->lock_count);
     if (e->lock_count)
 	return (int) e->lock_count;
     if (e->store_status == STORE_PENDING)
-	EBIT_SET(e->flags, RELEASE_REQUEST);
+	EBIT_SET(e->Sflag, RELEASE_REQUEST);
     assert(storePendingNClients(e) == 0);
-    if (EBIT_TEST(e->flags, RELEASE_REQUEST))
+    if (EBIT_TEST(e->Sflag, RELEASE_REQUEST))
 	storeRelease(e);
     else if (storeKeepInMemory(e)) {
 	storeSetMemStatus(e, IN_MEMORY);
@@ -258,9 +307,17 @@
 	e->mem_obj->request = NULL;
     } else {
 	storePurgeMem(e);
-	if (EBIT_TEST(e->flags, KEY_PRIVATE)) {
+	if (EBIT_TEST(e->Sflag, KEY_PRIVATE)) {
+        #ifdef	HPL_REPL
+        /*
+         * Squid/LRU is moving things around in the linked list in order
+         * to keep from bumping into them when purging from the LRU list.
+         */
+        debug(20, 4) ("storeUnlockObject: purged private node %d\n", e->n.ode.id);
+        #else	/* HPL_REPL */
 	    dlinkDelete(&e->lru, &store_list);
 	    dlinkAddTail(e, &e->lru, &store_list);
+        #endif	/* HPL_REPL */
 	}
     }
     return 0;
@@ -291,17 +348,16 @@
 }
 
 void
-storeSetPrivateKey(StoreEntry * e)
+storeSetPrivateKey(StoreEntry * e, unsigned hashed)
 {
     const cache_key *newkey;
     MemObject *mem = e->mem_obj;
-    if (e->key && EBIT_TEST(e->flags, KEY_PRIVATE))
+    if (EBIT_TEST(e->Sflag, KEY_PRIVATE))
 	return;			/* is already private */
-    if (e->key) {
-	if (e->swap_file_number > -1)
+    if (e->Sswap_file_number > -1)
 	    storeDirSwapLog(e, SWAP_LOG_DEL);
+    if (hashed)
 	storeHashDelete(e);
-    }
     if (mem != NULL) {
 	mem->id = getKeyCounter();
 	newkey = storeKeyPrivate(mem->url, mem->method, mem->id);
@@ -309,7 +365,7 @@
 	newkey = storeKeyPrivate("JUNK", METHOD_NONE, getKeyCounter());
     }
     assert(hash_lookup(store_table, newkey) == NULL);
-    EBIT_SET(e->flags, KEY_PRIVATE);
+    EBIT_SET(e->Sflag, KEY_PRIVATE);
     storeHashInsert(e, newkey);
 }
 
@@ -319,7 +375,7 @@
     StoreEntry *e2 = NULL;
     const cache_key *newkey;
     MemObject *mem = e->mem_obj;
-    if (e->key && !EBIT_TEST(e->flags, KEY_PRIVATE))
+    if (!EBIT_TEST(e->Sflag, KEY_PRIVATE))
 	return;			/* is already public */
     assert(mem);
     /*
@@ -332,19 +388,22 @@
      * If RELEASE_REQUEST is set, then ENTRY_CACHABLE should not
      * be set, and storeSetPublicKey() should not be called.
      */
-    assert(!EBIT_TEST(e->flags, RELEASE_REQUEST));
+#ifdef	HPL_REPL_DEBUG
+    if (EBIT_TEST(e->Sflag, RELEASE_REQUEST))
+	    debug(20, 1) ("assertion failed: RELEASE key %s, url %s\n", e->Skey, mem->url);
+#endif	/* HPL_REPL */
+    assert(!EBIT_TEST(e->Sflag, RELEASE_REQUEST));
     newkey = storeKeyPublic(mem->url, mem->method);
     if ((e2 = (StoreEntry *) hash_lookup(store_table, newkey))) {
 	debug(20, 3) ("storeSetPublicKey: Making old '%s' private.\n", mem->url);
-	storeSetPrivateKey(e2);
+	storeSetPrivateKey(e2, 1);
 	storeRelease(e2);
 	newkey = storeKeyPublic(mem->url, mem->method);
     }
-    if (e->key)
 	storeHashDelete(e);
-    EBIT_CLR(e->flags, KEY_PRIVATE);
+    EBIT_CLR(e->Sflag, KEY_PRIVATE);
     storeHashInsert(e, newkey);
-    if (e->swap_file_number > -1)
+    if (e->Sswap_file_number > -1)
 	storeDirSwapLog(e, SWAP_LOG_ADD);
 }
 
@@ -359,26 +418,26 @@
     e->lock_count = 1;		/* Note lock here w/o calling storeLock() */
     mem = e->mem_obj;
     mem->method = method;
+    e->Sswap_file_number = -1;
     if (neighbors_do_private_keys || !flags.hierarchical)
-	storeSetPrivateKey(e);
+	storeSetPrivateKey(e, 0);
     else
 	storeSetPublicKey(e);
     if (flags.cachable) {
-	EBIT_SET(e->flags, ENTRY_CACHABLE);
-	EBIT_CLR(e->flags, RELEASE_REQUEST);
+	EBIT_SET(e->Sflag, ENTRY_CACHABLE);
+	EBIT_CLR(e->Sflag, RELEASE_REQUEST);
     } else {
-	EBIT_CLR(e->flags, ENTRY_CACHABLE);
+	EBIT_CLR(e->Sflag, ENTRY_CACHABLE);
 	storeReleaseRequest(e);
     }
     e->store_status = STORE_PENDING;
     storeSetMemStatus(e, NOT_IN_MEMORY);
     e->swap_status = SWAPOUT_NONE;
-    e->swap_file_number = -1;
-    e->refcount = 0;
-    e->lastref = squid_curtime;
-    e->timestamp = 0;		/* set in storeTimestampsSet() */
+    e->Srefcount = 0;
+    e->Slastref = squid_curtime;
+    e->Stimestamp = 0;		/* set in storeTimestampsSet() */
     e->ping_status = PING_NONE;
-    EBIT_SET(e->flags, ENTRY_VALIDATED);
+    EBIT_SET(e->Sflag, ENTRY_VALIDATED);
     return e;
 }
 
@@ -386,8 +445,8 @@
 void
 storeExpireNow(StoreEntry * e)
 {
-    debug(20, 3) ("storeExpireNow: '%s'\n", storeKeyText(e->key));
-    e->expires = squid_curtime;
+    debug(20, 3) ("storeExpireNow: '%s'\n", storeKeyText(e->Skey));
+    e->Sexpires = squid_curtime;
 }
 
 /* Append incoming data from a primary server to an entry. */
@@ -399,14 +458,14 @@
     assert(len >= 0);
     assert(e->store_status == STORE_PENDING);
     if (len) {
-	debug(20, 5) ("storeAppend: appending %d bytes for '%s'\n",
+	debug(20, 6) ("storeAppend: appending %d bytes for '%s'\n",
 	    len,
-	    storeKeyText(e->key));
+	    storeKeyText(e->Skey));
 	storeGetMemSpace(len);
 	stmemAppend(&mem->data_hdr, buf, len);
 	mem->inmem_hi += len;
     }
-    if (EBIT_TEST(e->flags, DELAY_SENDING))
+    if (EBIT_TEST(e->Sflag, DELAY_SENDING))
 	return;
 #ifdef OPTIMISTIC_IO
     storeLockObject(e);
@@ -488,23 +547,25 @@
 	store_check_cachable_hist.no.non_get++;
     } else
 #endif
-    if (!EBIT_TEST(e->flags, ENTRY_CACHABLE)) {
+    if (!EBIT_TEST(e->Sflag, ENTRY_CACHABLE)) {
 	debug(20, 2) ("storeCheckCachable: NO: not cachable\n");
 	store_check_cachable_hist.no.not_entry_cachable++;
-    } else if (EBIT_TEST(e->flags, RELEASE_REQUEST)) {
+    } else if (EBIT_TEST(e->Sflag, RELEASE_REQUEST)) {
 	debug(20, 2) ("storeCheckCachable: NO: release requested\n");
 	store_check_cachable_hist.no.release_request++;
-    } else if (e->store_status == STORE_OK && EBIT_TEST(e->flags, ENTRY_BAD_LENGTH)) {
+    } else if (e->store_status == STORE_OK && EBIT_TEST(e->Sflag, ENTRY_BAD_LENGTH)) {
 	debug(20, 2) ("storeCheckCachable: NO: wrong content-length\n");
 	store_check_cachable_hist.no.wrong_content_length++;
-    } else if (EBIT_TEST(e->flags, ENTRY_NEGCACHED)) {
+    } else if (EBIT_TEST(e->Sflag, ENTRY_NEGCACHED)) {
 	debug(20, 3) ("storeCheckCachable: NO: negative cached\n");
 	store_check_cachable_hist.no.negative_cached++;
 	return 0;		/* avoid release call below */
-    } else if (e->mem_obj->inmem_hi > Config.Store.maxObjectSize) {
+    } else if ((e->mem_obj->reply->content_length > 0 &&
+		e->mem_obj->reply->content_length > Config.Store.maxObjectSize) ||
+		e->mem_obj->inmem_hi > Config.Store.maxObjectSize) {
 	debug(20, 2) ("storeCheckCachable: NO: too big\n");
 	store_check_cachable_hist.no.too_big++;
-    } else if (EBIT_TEST(e->flags, KEY_PRIVATE)) {
+    } else if (EBIT_TEST(e->Sflag, KEY_PRIVATE)) {
 	debug(20, 3) ("storeCheckCachable: NO: private key\n");
 	store_check_cachable_hist.no.private_key++;
     } else if (e->swap_status != SWAPOUT_NONE) {
@@ -515,21 +576,28 @@
 	 */
 	return 1;
     } else if (storeTooManyDiskFilesOpen()) {
-	debug(20, 2) ("storeCheckCachable: NO: too many disk files open\n");
+	debug(20, 3) ("storeCheckCachable: NO: too many disk files open\n");
 	store_check_cachable_hist.no.too_many_open_files++;
     } else if (fdNFree() < RESERVED_FD) {
-	debug(20, 2) ("storeCheckCachable: NO: too many FD's open\n");
+	debug(20, 3) ("storeCheckCachable: NO: too many FD's open\n");
 	store_check_cachable_hist.no.too_many_open_fds++;
+#ifdef	HPL_REPL
+    /*
+     * With the HPL replacement policies a low reference age should not
+     * prevent cacheability of an object.  We do not use LRU age at all.
+     */
+#else	/* HPL_REPL */
     } else if (storeExpiredReferenceAge() < 300) {
-	debug(20, 2) ("storeCheckCachable: NO: LRU Age = %d\n",
+	debug(20, 3) ("storeCheckCachable: NO: LRU Age = %d\n",
 	    storeExpiredReferenceAge());
 	store_check_cachable_hist.no.lru_age_too_low++;
+#endif	/* HPL_REPL */
     } else {
 	store_check_cachable_hist.yes.Default++;
 	return 1;
     }
     storeReleaseRequest(e);
-    EBIT_CLR(e->flags, ENTRY_CACHABLE);
+    EBIT_CLR(e->Sflag, ENTRY_CACHABLE);
     return 0;
 }
 
@@ -566,13 +634,13 @@
 void
 storeComplete(StoreEntry * e)
 {
-    debug(20, 3) ("storeComplete: '%s'\n", storeKeyText(e->key));
+    debug(20, 3) ("storeComplete: '%s'\n", storeKeyText(e->Skey));
     if (e->store_status != STORE_PENDING) {
 	/*
 	 * if we're not STORE_PENDING, then probably we got aborted
 	 * and there should be NO clients on this entry
 	 */
-	assert(EBIT_TEST(e->flags, ENTRY_ABORTED));
+	assert(EBIT_TEST(e->Sflag, ENTRY_ABORTED));
 	assert(e->mem_obj->nclients == 0);
 	return;
     }
@@ -580,7 +648,7 @@
     e->store_status = STORE_OK;
     assert(e->mem_status == NOT_IN_MEMORY);
     if (!storeEntryValidLength(e)) {
-	EBIT_SET(e->flags, ENTRY_BAD_LENGTH);
+	EBIT_SET(e->Sflag, ENTRY_BAD_LENGTH);
 	storeReleaseRequest(e);
     }
 #if USE_CACHE_DIGESTS
@@ -602,11 +670,11 @@
     MemObject *mem = e->mem_obj;
     assert(e->store_status == STORE_PENDING);
     assert(mem != NULL);
-    debug(20, 6) ("storeAbort: %s\n", storeKeyText(e->key));
+    debug(20, 6) ("storeAbort: %s\n", storeKeyText(e->Skey));
     storeLockObject(e);		/* lock while aborting */
     storeNegativeCache(e);
     storeReleaseRequest(e);
-    EBIT_SET(e->flags, ENTRY_ABORTED);
+    EBIT_SET(e->Sflag, ENTRY_ABORTED);
     storeSetMemStatus(e, NOT_IN_MEMORY);
     /* No DISK swap for negative cached object */
     e->swap_status = SWAPOUT_NONE;
@@ -634,7 +702,7 @@
 #if USE_ASYNC_IO
     aioCancel(-1, e);
 #endif
-    if (e->swap_file_number > -1) {
+    if (e->Sswap_file_number > -1) {
 #if USE_ASYNC_IO
 	/* Need to cancel any pending ASYNC writes right now */
 	if (mem->swapout.fd >= 0)
@@ -656,17 +724,63 @@
     static time_t last_check = 0;
     int pages_needed;
     dlink_node *m;
-    dlink_node *head;
     dlink_node *prev = NULL;
+    int locked = 0;
+    #ifdef	HPL_REPL
+    heap_p heap = inmem_heap;
+    _HEAPKEY age, min_age = 0;
+    MemObject *locked_entries = NULL;
+    MemObject *mo;
+    #else	/* HPL_REPL */
+    dlink_node *head;
+    #endif	/* HPL_REPL */
+
     if (squid_curtime == last_check)
 	return;
     last_check = squid_curtime;
     pages_needed = (size / SM_PAGE_SIZE) + 1;
+    debug(20, 3) ("storeGetMemSpace: inuse %d, need %d, have %d\n",
+		  memInUse(MEM_STMEM_BUF), pages_needed, store_pages_max);
     if (memInUse(MEM_STMEM_BUF) + pages_needed < store_pages_max)
 	return;
     if (store_rebuilding)
 	return;
     debug(20, 2) ("storeGetMemSpace: Starting, need %d pages\n", pages_needed);
+    #ifdef	HPL_REPL
+    while (heap_nodes(heap) > 0) {
+        age = heap_peepminkey(heap);
+	mo = heap_extractmin(heap);
+	e = mo->entry;
+	if (storeEntryLocked(e)) {
+	  locked++;
+	  debug(20, 5) ("storeGetMemSpace: locked key %s\n", storeKeyText(e->Skey));
+	  mo->n.ext = locked_entries;
+	  locked_entries = mo;
+	  continue;
+	}
+	mo->n.ode.id = -1;		/* no longer in the heap */
+	released++;
+	debug(20, 3) ("Released memory object with key %f size %d refs %d url %s\n",
+		age, e->Sswap_file_sz, e->Srefcount, e->mem_obj->url);
+	min_age = age;
+	storePurgeMem(e);
+	if (memInUse(MEM_STMEM_BUF) + pages_needed < store_pages_max)
+	    break;
+    }
+    /*
+     * Increase the heap age factor.
+     */
+    if (min_age > 0)
+      heap->age = min_age;
+    /*
+     * Reinsert all bumped locked entries back into heap...
+     */
+    while (mo = locked_entries) {
+      locked_entries = mo->n.ext;
+      heap_insert(heap, mo);
+    }
+
+    #else	/* HPL_REPL */
     head = inmem_list.head;
     for (m = inmem_list.tail; m; m = prev) {
 	if (m == head)
@@ -674,6 +788,7 @@
 	prev = m->prev;
 	e = m->data;
 	if (storeEntryLocked(e)) {
+	    locked++;
 	    dlinkDelete(m, &inmem_list);
 	    dlinkAdd(e, m, &inmem_list);
 	    continue;
@@ -683,9 +798,12 @@
 	if (memInUse(MEM_STMEM_BUF) + pages_needed < store_pages_max)
 	    break;
     }
-    debug(20, 3) ("storeGetMemSpace stats:\n");
-    debug(20, 3) ("  %6d HOT objects\n", hot_obj_count);
-    debug(20, 3) ("  %6d were released\n", released);
+    #endif	/* HPL_REPL */
+    debug(20, 3) ("storeGetMemSpace: released %d/%d locked %d\n",
+		  released, hot_obj_count, locked);
+    debug(20, 4) ("storeGetMemSpace stats:\n");
+    debug(20, 4) ("  %6d HOT objects\n", hot_obj_count);
+    debug(20, 4) ("  %6d were released\n", released);
 }
 
 /* The maximum objects to scan for maintain storage space */
@@ -709,26 +827,150 @@
     int locked = 0;
     int expired = 0;
     int max_scan;
-    int max_remove;
-    double f;
     static time_t last_warn_time = 0;
+    SwapDir *SD;
+    unsigned i;
+    #ifdef	HPL_REPL
+
+    #ifdef	HPL_REPL_DEBUG
+    if (!verify_heap_property(store_heap)) {
+	debug(20, 1) ("Heap property violated!\n");
+    }
+    #endif	/* HPL_REPL_DEBUG */
+    #endif	/* HPL_REPL */
+
     /* We can't delete objects while rebuilding swap */
     if (store_rebuilding) {
 	eventAdd("MaintainSwapSpace", storeMaintainSwapSpace, NULL, 1.0, 1);
 	return;
     } else {
-	f = (double) (store_swap_size - store_swap_low) / (store_swap_high - store_swap_low);
+        double f;
+	f = ((double) (store_swap_size - store_swap_low) /
+	     (store_swap_high - store_swap_low));
 	f = f < 0.0 ? 0.0 : f > 1.0 ? 1.0 : f;
 	max_scan = (int) (f * 400.0 + 100.0);
-	max_remove = (int) (f * 70.0 + 10.0);
-	eventAdd("MaintainSwapSpace", storeMaintainSwapSpace, NULL, 1.0 - f, 1);
+	eventAdd("MaintainSwapSpace", storeMaintainSwapSpace, NULL, 10*(1.0 - f), 1);
+    }
+
+#if 0
+    if (store_swap_size < store_swap_low) {
+        /* Just return since we still have enougy memory */
+        return; 
     }
-    debug(20, 3) ("storeMaintainSwapSpace: f=%f, max_scan=%d, max_remove=%d\n",
-	f, max_scan, max_remove);
+#endif
+    {
+        int dirmax = -1;
+	unsigned long dirmaxval = 0;
+
+	for (SD = Config.cacheSwap.swapDirs +
+	     (i = Config.cacheSwap.n_configured); i--; ) {
+	    (--SD)->riddance = 0;
+	    if (!SD->flags.read_only && SD->cur_size >= SD->low_size) {
+		unsigned long tval;
+		tval = (SD->cur_size - SD->low_size) / SD->win_size;
+		if (tval > dirmaxval)
+		    dirmaxval = tval, dirmax = i;
+		SD->riddance = (40 * tval) >> STORE_GRAN_ORDER;
+	        debug(20, 4) ("storeMaintainSwapSpace: Remove %d in swapdir %s\n",
+		 SD->riddance, SD->path);
+	    }
+	}
+	if (dirmax >= 0) {
+	    SD[dirmax].riddance += 10;
+	    debug(20, 3) ("storeMaintainSwapSpace: Aggressive reduction for swapdir %s\n",
+		Config.cacheSwap.swapDirs[dirmax].path);
+	}
+    }
+
+    debug(20, 2) ("storeMaintainSwapSpace: Starting, max_scan=%d\n",
+	max_scan);
+
+#ifdef	HPL_REPL
+
+    for (i = Config.cacheSwap.n_configured; i--; SD++) {
+        heap_p heap = SD->heap;
+        _HEAPKEY age, min_age;
+        StoreEntry *locked_entries;
+	if (!SD->riddance)
+	   continue;
+	min_age = 0; locked_entries = 0;
+    while (heap_nodes(heap) > 0) {
+        age = heap_peepminkey(heap);
+	e = heap_extractmin(heap);
+	e->n.ode.id = -1;				/* no longer in the heap */
+	scanned++;
+	if (storeEntryLocked(e)) {
+	    /*
+	     * Entry is in use ... put it in a linked list to ignore it.
+	     */
+#if 0	/* we're never inserting specials, so don't check for it */
+	    if (!EBIT_TEST(e->Sflag, ENTRY_SPECIAL))
+#else
+	    assert(!EBIT_TEST(e->Sflag, ENTRY_SPECIAL));
+#endif
+	    {
+		/*
+		 * If this was a "SPECIAL" do not add it back into the heap.
+		 * It will always be "SPECIAL" and therefore never removed.
+		 */
+		debug(20, 4) ("storeMaintainSwapSpace: locked url %s\n",
+			      (e->mem_obj && e->mem_obj->url) ? e->mem_obj->url : storeKeyText(e->Skey));
+		e->n.ext = locked_entries;
+		locked_entries = e;
+	    }
+	    locked++;
+	    continue;
+	} else if (storeCheckExpired(e)) {
+	    /*
+	     * Note: This will not check the reference age ifdef HPL_REPL,
+	     * but it does some other useful checks...
+	     */
+	    expired++;
+	    debug(20, 3) ("Released store object age %f size %d refs %d key %s\n",
+			  age, e->Sswap_file_sz, e->Srefcount, storeKeyText(e->Skey));
+	    min_age = age;
+	    storeRelease(e);
+	} else {
+	    /*
+	     * Did not expire the object so we need to add it back into the heap!
+	     */
+	    debug(20, 5) ("storeMaintainSwapSpace: non-expired %s\n", storeKeyText(e->Skey));
+	    e->n.ext = locked_entries;
+	    locked_entries = e;
+	    continue;
+	}
+	if (SD->cur_size <= SD->low_size
+	    || expired >= SD->riddance
+	    || scanned >= max_scan)
+	    break;
+    }
+    /*
+     * Bump the heap age factor.
+     */
+    if (min_age > 0)
+	heap->age = min_age;
+
+    /*
+     * Reinsert all bumped locked entries back into heap...
+     */
+    while (e = locked_entries) {
+      locked_entries = e->n.ext;
+      heap_insert(heap, e);
+    }
+    }
+
+#else	/* HPL_REPL */
+
     for (m = store_list.tail; m; m = prev) {
+	unsigned dirn;
 	prev = m->prev;
 	e = m->data;
-	scanned++;
+	dirn = e->Sswap_file_number >> SWAP_DIR_SHIFT;
+	if (dirn == dirmax) {
+	    if (ext_max_scan-- < 0)
+		break;
+	} else if (++scanned >= max_scan)
+	    goto enough;
 	if (storeEntryLocked(e)) {
 	    /*
 	     * If there is a locked entry at the tail of the LRU list,
@@ -743,19 +985,27 @@
 	    }
 	    locked++;
 	} else if (storeCheckExpired(e)) {
+	    if (dirn == dirmax)
+		min_removehigh--;
 	    expired++;
 	    storeRelease(e);
 	}
 	if (expired >= max_remove)
-	    break;
+	    goto enough;
 	if (scanned >= max_scan)
+enough:	   if (min_removehigh <= 0)
 	    break;
     }
-    debug(20, 3) ("storeMaintainSwapSpace stats:\n");
-    debug(20, 3) ("  %6d objects\n", memInUse(MEM_STOREENTRY));
-    debug(20, 3) ("  %6d were scanned\n", scanned);
-    debug(20, 3) ("  %6d were locked\n", locked);
-    debug(20, 3) ("  %6d were expired\n", expired);
+
+#endif	/* HPL_REPL */
+
+    debug(20, (expired?2:3)) ("storeMaintainSwapSpace: scanned %d/%d removed %d locked %d\n",
+		  scanned, max_scan, expired, locked);
+    debug(20, 4) ("storeMaintainSwapSpace stats:\n");
+    debug(20, 4) ("  %6d objects\n", memInUse(MEM_STOREENTRY));
+    debug(20, 4) ("  %6d were scanned\n", scanned);
+    debug(20, 4) ("  %6d were locked\n", locked);
+    debug(20, 4) ("  %6d were expired\n", expired);
     if (store_swap_size < Config.Swap.maxSize)
 	return;
     if (squid_curtime - last_warn_time < 10)
@@ -771,7 +1021,7 @@
 void
 storeRelease(StoreEntry * e)
 {
-    debug(20, 3) ("storeRelease: Releasing: '%s'\n", storeKeyText(e->key));
+    debug(20, 3) ("storeRelease: Releasing: '%s'\n", storeKeyText(e->Skey));
     /* If, for any reason we can't discard this object because of an
      * outstanding request, mark it for pending release */
     if (storeEntryLocked(e)) {
@@ -787,7 +1037,7 @@
     aioCancel(-1, e);
 #endif
     if (store_rebuilding) {
-	storeSetPrivateKey(e);
+	storeSetPrivateKey(e, 1);
 	if (e->mem_obj) {
 	    storeSetMemStatus(e, NOT_IN_MEMORY);
 	    destroy_MemObject(e);
@@ -801,14 +1051,15 @@
 	return;
     }
     storeLog(STORE_LOG_RELEASE, e);
-    if (e->swap_file_number > -1) {
-	storeUnlinkFileno(e->swap_file_number);
-	storeDirMapBitReset(e->swap_file_number);
+    if (e->Sswap_file_number > -1) {
+	storeUnlinkFileno(e->Sswap_file_number);
+	storeDirMapBitReset(e->Sswap_file_number);
 	if (e->swap_status == SWAPOUT_DONE)
-	    if (EBIT_TEST(e->flags, ENTRY_VALIDATED))
-		storeDirUpdateSwapSize(e->swap_file_number, e->swap_file_sz, -1);
-	if (!EBIT_TEST(e->flags, KEY_PRIVATE))
+	    if (EBIT_TEST(e->Sflag, ENTRY_VALIDATED))
+		storeDirUpdateSwapSize(e->Sswap_file_number, e->Sswap_file_sz, -1);
+	if (!EBIT_TEST(e->Sflag, KEY_PRIVATE))
 	    storeDirSwapLog(e, SWAP_LOG_DEL);
+	set_swap_file_number(e, -1);
     }
     storeSetMemStatus(e, NOT_IN_MEMORY);
     destroy_StoreEntry(e);
@@ -852,8 +1103,8 @@
     /*
      * SPECIAL, PUBLIC entries should be "locked"
      */
-    if (EBIT_TEST(e->flags, ENTRY_SPECIAL))
-	if (!EBIT_TEST(e->flags, KEY_PRIVATE))
+    if (EBIT_TEST(e->Sflag, ENTRY_SPECIAL))
+	if (!EBIT_TEST(e->Sflag, KEY_PRIVATE))
 	    return 1;
     return 0;
 }
@@ -865,7 +1116,7 @@
     const HttpReply *reply;
     assert(e->mem_obj != NULL);
     reply = e->mem_obj->reply;
-    debug(20, 3) ("storeEntryValidLength: Checking '%s'\n", storeKeyText(e->key));
+    debug(20, 3) ("storeEntryValidLength: Checking '%s'\n", storeKeyText(e->Skey));
     debug(20, 5) ("storeEntryValidLength:     object_len = %d\n",
 	objectLen(e));
     debug(20, 5) ("storeEntryValidLength:         hdr_sz = %d\n",
@@ -874,17 +1125,17 @@
 	reply->content_length);
     if (reply->content_length < 0) {
 	debug(20, 5) ("storeEntryValidLength: Unspecified content length: %s\n",
-	    storeKeyText(e->key));
+	    storeKeyText(e->Skey));
 	return 1;
     }
     if (reply->hdr_sz == 0) {
 	debug(20, 5) ("storeEntryValidLength: Zero header size: %s\n",
-	    storeKeyText(e->key));
+	    storeKeyText(e->Skey));
 	return 1;
     }
     if (e->mem_obj->method == METHOD_HEAD) {
 	debug(20, 5) ("storeEntryValidLength: HEAD request: %s\n",
-	    storeKeyText(e->key));
+	    storeKeyText(e->Skey));
 	return 1;
     }
     if (reply->sline.status == HTTP_NOT_MODIFIED)
@@ -894,10 +1145,10 @@
     diff = reply->hdr_sz + reply->content_length - objectLen(e);
     if (diff == 0)
 	return 1;
-    debug(20, 3) ("storeEntryValidLength: %d bytes too %s; '%s'\n",
+    debug(20, 4) ("storeEntryValidLength: %d bytes too %s; '%s'\n",
 	diff < 0 ? -diff : diff,
 	diff < 0 ? "big" : "small",
-	storeKeyText(e->key));
+	storeKeyText(e->Skey));
     return 0;
 }
 
@@ -924,6 +1175,72 @@
     debug(20, 1) ("Max Swap size: %d KB\n", Config.Swap.maxSize);
 }
 
+#ifdef	HPL_REPL
+
+/*
+ * For a description of these cache replacement policies see --
+ http://www.hpl.hp.com/personal/John_Dilley/caching/wcw.html
+ */
+
+
+/*
+ * Key generation function to implement the LFU-DA policy (Least Frequently
+ * Used with Dynamic Aging).  Similar to classical LFU but with aging to
+ * handle turnover of the popular document set.  Maximizes byte hit rate by
+ * keeping more currently popular objects in cache regardless of size.
+ * Achieves lower hit rate than GDS because there are more large objects in
+ * cache (so less room for smaller popular objects).
+ * 
+ * This version implements a tie-breaker based upon recency (e->lastref):
+ * for objects that have the same reference count the most recent object
+ * wins (gets a higher key value).
+ */
+double
+HeapKeyGen_StoreEntry_LFUDA(void * entry, double age)
+{
+  StoreEntry * e = entry;
+  /* dangerous arithmetic after the year 2038 */
+  double tie = (e->Slastref>1)?(1.0/e->Slastref):1;
+  return age + e->Srefcount - tie;
+}
+
+
+/*
+ * Key generation function to implement the GDS-Frequency policy.
+ * Similar to Greedy Dual-Size Hits policy, but adds aging of documents to
+ * prevent pollution.  Maximizes object hit rate by keeping more small,
+ * popular objects in cache.  Achieves lower byte hit rate than LFUDA
+ * because there are fewer large objects in cache.
+ * 
+ * This version implements a tie-breaker based upon recency (e->lastref):
+ * for objects that have the same reference count the most recent object
+ * wins (gets a higher key value).
+ */
+double
+HeapKeyGen_StoreEntry_GDSF(void * entry, double age)
+{
+  StoreEntry * e = entry;
+  double size = e->Sswap_file_sz ? e->Sswap_file_sz : 1.0;
+  /* dangerous arithmetic after the year 2038 */
+  double tie = (e->Slastref>1)?(1.0/e->Slastref):1;
+  return age + ((double)e->Srefcount / size) - tie;
+}
+
+/* 
+ * Key generation function to implement the LRU policy.  Normally one would
+ * not do this with a heap -- use the linked list instead.  For testing and
+ * performance characterization it was useful.  Don't use it unless you are
+ * trying to compare performance among heap-based replacement policies...
+ */
+double
+HeapKeyGen_StoreEntry_LRU(void * entry, double age)
+{
+  StoreEntry * e = entry;
+  return e->Slastref;
+}
+
+#endif	/* HPL_REPL */
+
 void
 storeInit(void)
 {
@@ -941,9 +1258,43 @@
 	    ERROR_BUF_SZ);
 	fatal(tmp_error_buf);
     }
-    storeDirOpenSwapLogs();
+    #ifdef	HPL_REPL
+    /*
+     * Create new heaps with cache replacement policies attached to them.
+     * The cache replacement policy is specified as either GDSF or LFUDA in
+     * the squid.conf configuration file.  Note that the replacement policy
+     * applies only to the disk replacement algorithm.  Memory replacement
+     * always uses GDSF since we want to maximize object hit rate.
+     */
+    inmem_heap = new_heap(1000, HeapKeyGen_StoreEntry_GDSF,
+		    offsetof(MemObject, n.ode));
+
+    store_policy = HeapKeyGen_StoreEntry_GDSF;
+
+    if (Config.replPolicy)
+      if (tolower(Config.replPolicy[0]) == 'g')
+	debug(20, 1) ("Using GDSF disk replacement policy\n");
+      else if (tolower(Config.replPolicy[0]) == 'l') {
+	if (tolower(Config.replPolicy[1]) == 'f') {
+	  debug(20, 1) ("Using LFUDA disk replacement policy\n");
+	  store_policy = HeapKeyGen_StoreEntry_LFUDA;
+	} else if (tolower(Config.replPolicy[1]) == 'r') {
+	  debug(20, 1) ("Using LRU heap disk replacement policy\n");
+	  store_policy = HeapKeyGen_StoreEntry_LRU;
+	}
+      } else
+	  debug(20, 1) ("Unrecognized replacement_policy; using GDSF\n");
+    else
+	debug(20, 1) ("Using default disk replacement policy (GDSF)\n");
+
+    #else	/* HPL_REPL */
+
     store_list.head = store_list.tail = NULL;
     inmem_list.head = inmem_list.tail = NULL;
+
+    #endif	/* HPL_REPL */
+
+    storeDirOpenSwapLogs();
     stackInit(&LateReleaseStack);
     eventAdd("storeLateRelease", storeLateRelease, NULL, 1.0, 1);
     storeRebuildStart();
